rm(list=ls())
###############################################################
####
####  FreGL construction: Script unite all proc_Sample files into One file with
####    two column devoted to each sample: CN and BA (major allele counts) 
####
##################################################################

### !!!!! Put the PATH to your data  !!!!


pPath<-"C:/GAP_AffymetrixSNP6_workflow_homepage/"

inputPath<-paste(pPath,"Results_Plots/",sep="")
outputPath<-paste(pPath,"",sep="")

### !!!!! Give your favorit name to output_infoFileName, if you want   !!!!
CN_BA_fileName<-"CN_BA_Affy6_MySeries.txt"


### Annotation files
### !!!!! Correct the names of annotation files according to script_0  !!!!

CN_annot<-read.csv(paste(pPath,"CN_annot_Affy6_Version.csv",sep=""),header=T,fill=T,stringsAsFactors = F,row.names=1)
SNP_annot<-read.csv(paste(pPath,"SNP_annot_Affy6_Version.csv",sep=""),header=T,fill=T,stringsAsFactors = F,row.names=1)
CN_annot<-data.matrix(CN_annot)
SNP_annot<-data.matrix(SNP_annot)
C_Ind<-1;C_Chr<-2;C_Pos<-4



#### proc_sample colnames:
c_ind<-1;c_is<-2;c_if<-3;c_isGen<-4;c_ifGen<-5;c_isCN<-6;c_ifCN<-7;c_chr<-8;c_len<-9;
c_cnBP<-10;c_adBP<-11;c_cn<-12;c_adL<-13;c_adH<-14;c_nC<-15;c_nA<-16;c_nS<-17   
c_CN<-18;c_BA<-19;c_conf<-20;c_sb<-21;c_CN1<-22;c_BA1<-23;c_rnk1<-24

### Source file needs SNP_annot file defined above
source(paste(pPath,"script_functions_FrGL_construction.R",sep=""))

### !!!!! All proc_Sample files from Results_Plots folder will be processed

segFiles <- list.files(inputPath, pattern="proc_",full.names=T) 

fileNames <- gsub(inputPath,"",segFiles) 
fileNames <- gsub("proc_","",fileNames) 
fileNames <- gsub(".txt","",fileNames) 

nSample<-length(segFiles)

#########################################
######## Union of segments in all segmented files: getting Fragile segments

TMP<-numeric(0)
for(ii in 1:nSample){

tmp<-read.delim(segFiles[ii],header=T,sep="\t")
tmp<-data.matrix(tmp)

tt<-which(is.na(tmp[,c_is]));if(length(tt)!=0){tmp<-tmp[-tt,]}
tt<-which(is.na(tmp[,c_if]));if(length(tt)!=0){tmp<-tmp[-tt,]}

tmp<-checkZero(tmp)
tmp<-getConfidence(tmp)
tmp<-shrinkReprTMP(tmp)
TMP<-c(TMP,tmp[,c_is])

}##ii


TMP<-union(TMP,TMP)
TMP<-TMP[order(TMP,decreasing=F)]

TMP<-cbind(TMP,TMP,matrix(0,length(TMP),7))
TMP[,1]<-seq(1,dim(TMP)[[1]])

for(k in 1:(dim(TMP)[[1]]-1)){
TMP[k,c_if]<-TMP[k+1,c_is]-1
}
TMP[dim(TMP)[[1]],c_if]<-tmp[dim(tmp)[[1]],c_if]
#TMP[,c_len]<-TMP[,c_if]-TMP[,c_is]
colnames(TMP)<-ColNamesTMP


#########################################
######## Final polish of segmented files and filling up the Fragile

CN<-TMP

ii<-1
for(ii in 1:nSample){

tmp<-read.delim(segFiles[ii],header=T,sep="\t")
tmp<-data.matrix(tmp)

tt<-which(is.na(tmp[,c_is]));if(length(tt)!=0){tmp<-tmp[-tt,]}
tt<-which(is.na(tmp[,c_if]));if(length(tt)!=0){tmp<-tmp[-tt,]}

tmp<-checkZero(tmp)
tmp<-fitSmallGermHomozyg(tmp,Length=500)
tmp<-getConfidence(tmp)
tmp<-shrinkReprTMP(tmp)
tmp<-checkSmallDiscrepancies(tmp,Length=100)
tmp<-checkGermHomozygosities(tmp,Length=500)
tmp<-getConfidence(tmp)
tmp<-shrinkReprTMP(tmp)


CN<-cbind(CN,TMP[,8:9])
TT<-dim(CN)[[2]]
colnames(CN)[(TT-1):TT]<-paste(c("CN_","BA_"),fileNames[ii],sep="")
CN[,TT-1]<-100
CN[,TT]<-99

k<-1
for(k in 1:dim(tmp)[[1]]){
	tt<-which(CN[,c_is]>=tmp[k,c_is])
	if(length(tt)>0){
		kk<-which(CN[tt,c_if]<=tmp[k,c_if])
		if(length(kk)>0){
			CN[tt[kk],TT-1]<-tmp[k,c_CN]
			CN[tt[kk],TT]<-tmp[k,c_BA]
		}
	}
}#k

}#ii

########################################
####### Add annotation

c_ind<-1;c_is<-2;c_if<-3;c_posS<-4;c_posF<-5;c_isCN<-6;c_ifCN<-7;c_chr<-8;c_len<-9;

CN[,c_chr]<-SNP_annot[CN[,c_is],C_Chr]+(SNP_annot[CN[,c_is],C_Chr+1]-1)/2
CN[,c_len]<-CN[,c_if]-CN[,c_is]+1

#########################################
######## Final of the Fragile construction

######## Correct redundant rows

dim(CN)

for(j in 1:4){
for(k in 2:(dim(CN)[[1]]-1)){
if((CN[k,c_chr]==CN[k+1,c_chr])&&(CN[k,c_len]==(j-1))){
CN[k+1,c_is]<-CN[k,c_is]
CN[k+1,c_len]<-CN[k+1,c_len]+CN[k,c_len]
CN[k,1]<-0
}
}

tt<-which(CN[,c_ind]==0)
if(length(tt)>0){CN<-CN[-tt,]}
dim(CN)
}#j


for(k in 1:(dim(CN)[[1]]-1)){
str1<-as.numeric(c(CN[k,c_chr],CN[k,10:dim(CN)[[2]]]))
str2<-as.numeric(c(CN[k+1,c_chr],CN[k+1,10:dim(CN)[[2]]]))
tt<-sign(abs(str1-str2))
if(sum(tt)==0){
CN[k+1,c_is]<-CN[k,c_is]
CN[k+1,c_len]<-CN[k,c_len]+CN[k+1,c_len]
CN[k,c_ind]<-0
}
}

tt<-which(CN[,c_ind]==0)
if(length(tt)>0){CN<-CN[-tt,]}
dim(CN)


############ Saving data

CN[,c_posS]<-SNP_annot[CN[,c_is],C_Pos]
CN[,c_posF]<-SNP_annot[CN[,c_if],C_Pos]

fName<-paste(outputPath,CN_BA_fileName,sep="")
write.table(CN, file = fName,quote=F,row.names=F,col.names=T,sep="\t")

###########  END of SCRIPT


which(CN[,10:181]==100)